;
; console.asm - fast CHROUT replacement for screen
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;**************************************************
;Chrout to screen
;
;No known bugs in c64 mode
;
;Do not optimize further! ;)
;**************************************************


;SMOOTHSCROLL	= 0			;-)

cclr		lda $0288		;clear screen
		ora #$80
		tay
		#lda0
		tax
		clc
ce54d		sty $d9,x
		adc #40
		bcc ce555
		iny
ce555		inx
		cpx #26
		bcc ce54d
		lda #$ff
		sta $d9,x
		ldx #24
ce560		jsr cclearoneline	;e9ff
		dex
		bpl ce560

chome		ldy #0
		sty $d3			;X
		sty $d6			;Y

; set address of curent screen line

csetaddrofcurline ldx $d6		;Y
		lda $d3			;X
ce570		ldy $d9,x
		bmi ce57c
		clc
		adc #40
		sta $d3			;X
		dex
		bpl ce570
ce57c		jsr ccalcscraddress	;e9f0
		lda #39
		inx
ce582		ldy $d9,x
		bmi ce58c
		clc
		adc #40
		inx
		bpl ce582
ce58c		sta $d5			;current logical linelength
		jmp csynccoloraddr	;ea24

cconv		.byte $80,$81,$82,$83,$84,$85,$86,$87
		.byte $88,$89,$8a,$8b,$8c,$8d,$8e,$8f
		.byte $90,$91,$92,$93,$94,$95,$96,$97
		.byte $98,$99,$9a,$9b,$9c,$9d,$9e,$9f
		.byte $20,$21,$ff,$23,$24,$25,$26,$27
		.byte $28,$29,$2a,$2b,$2c,$2d,$2e,$2f
		.byte $30,$31,$32,$33,$34,$35,$36,$37
		.byte $38,$39,$3a,$3b,$3c,$3d,$3e,$3f
		.byte $00,$01,$02,$03,$04,$05,$06,$07
		.byte $08,$09,$0a,$0b,$0c,$0d,$0e,$0f
		.byte $10,$11,$12,$13,$14,$15,$16,$17
		.byte $18,$19,$1a,$1b,$1c,$1d,$1e,$1f
		.byte $40,$41,$42,$43,$44,$45,$46,$47
		.byte $48,$49,$4a,$4b,$4c,$4d,$4e,$4f
		.byte $50,$51,$52,$53,$54,$55,$56,$57
		.byte $58,$59,$5a,$5b,$5c,$5d,$5e,$5f

		.byte $80,$81,$82,$83,$84,$85,$86,$87
		.byte $88,$89,$8a,$8b,$8c,$8d,$8e,$8f
		.byte $90,$91,$92,$93,$94,$95,$96,$97
		.byte $98,$99,$9a,$9b,$9c,$9d,$9e,$9f
		.byte $60,$61,$62,$63,$64,$65,$66,$67
		.byte $68,$69,$6a,$6b,$6c,$6d,$6e,$6f
		.byte $70,$71,$72,$73,$74,$75,$76,$77
		.byte $78,$79,$7a,$7b,$7c,$7d,$7e,$7f
		.byte $40,$41,$42,$43,$44,$45,$46,$47
		.byte $48,$49,$4a,$4b,$4c,$4d,$4e,$4f
		.byte $50,$51,$52,$53,$54,$55,$56,$57
		.byte $58,$59,$5a,$5b,$5c,$5d,$5e,$5f
		.byte $60,$61,$62,$63,$64,$65,$66,$67
		.byte $68,$69,$6a,$6b,$6c,$6d,$6e,$6f
		.byte $70,$71,$72,$73,$74,$75,$76,$77
		.byte $78,$79,$7a,$7b,$7c,$7d,$7e,$5e

;-------------------------------------
;Let's use the kernal chrout instead...
;
oldconsole	#psr $e716
		txa
		#ldx_l_ help_x_exp
		jmp switch_norm
;--------------------------
;not console write...
;
oldchroutjmp	txa
		#ldx_l_ help_x_exp
		jmp r_chrout
;--------------------------
newchrout	#stx_l_ help_x_exp
		tax
		lda $288
		eor #4
		bne oldconsole		;$400?
		sta $d0			;Used to force reinput... (screen changes)
		#sty_l_a help_y_exp
		ldy $d3			;X
		stx $d7
		lda cconv,x
		bpl coutnormal
		cmp #$ff
		bcc ccontrol1
		gcs newconsolein
;----------------------
newconsole	#plx_a
		lda $288
		eor #4
		bne oldconsole		;$400?
		sta $d0			;Used to force reinput... (screen changes)
		lda buffer_input_exp	;stdin not standard...
		eor #STDIN
		beq euoeu
		#psr exit2basic
euoeu		#sty_l_a help_y_exp
		ldy $d3			;X
		stx $d7

		lda cconv,x
		bpl coutnormal
	        cmp #$ff
		bcc ccontrol1
newconsolein   	lda $d4
		eor #1
		sta $d4
		lda #$22		; quote mark
		bne coutnormal
ccontrol1	txa
		bmi ccontrol2
		jmp ccontrol1real
ccontrol2	and #$1f
		jmp ccontrol2real

; fill screen at current position

coutnormal	ldx $c7
		beq *+4
coutinverse	ora #$80

		ldx $d8
		beq *+8
		dec $d8
		beq *+4
		lsr $d4

;                  lda #2   Cursor not important here
;                  sta $cd
;                  jsr csynccoloraddr ;ea24
					;
		ldx $d1
		stx $f3
					;
		sta ($d1),y
		lda $d2			;inlined csynccoloraddr
		eor #$dc		;$400-$7ff!!!!
		sta $f4
		lda $0286
		sta ($f3),y

		inc $d3			;X

		cpy #39
		bcc ce8c2qa
		beq *+6
		cpy #79
		bcc ce8c2qa
		bne ce8c2qaclc		;should not happen

		ldx $d6			;Y
		cpx #25
		beq *+4
		inc $d6			;Y

		cpy $d5			;current logical linelength
		bcc ce8c2qa
		jsr cadvancecursorchk
ce8c2qaclc	clc
ce8c2qa					;C=0


; return from output to the screen

cexit2		#ldy_l_a help_y_exp
		#ldatax help_x_exp
		lda $d7
		cli			;What's this???
		jmp switch_norm

cexit		clc
		lda $d8
		beq cexit2
		lsr $d4
                gpl ce8c2qaclc

; get/insert new line

cadvancecursorchk lda $d5		;current logical linelength
		cmp #79
		beq ce6f7
		lda $0292		;Auto scroll down?
		bne cinsertblank

		ldx $d6			;Y
		cpx #25
		bcc ce6da
		jsr cscrollscr
		dec $d6			;Y
		ldx $d6			;Y

ce6da		asl $da,x
		sec
		ror $da,x
		asl $d9,x
		lsr $d9,x
		lda $d5			;current logical linelength
		adc #40
		sta $d5			;current logical linelength

ce6ed		lda $d9,x
		bmi ce6f4
		dex
		bne ce6ed
ce6f4		jmp ccalcscraddress	;e9f0

ce6f7		dec $d6			;Y
		jsr cnextline
		#lda0
		sta $d3			;X
		rts

; move backwards over a line boundary

cmovebackoverboundary
		ldx $d6			;Y
		bne ce70b
		stx $d3			;X  in left top corner already...
		pla
		pla
		jmp cexit
ce70b		dex
		stx $d6			;Y
		jsr csetaddrofcurline
		ldy $d5			;current logical linelength
		sty $d3			;X
		rts
;--------------------------------------------
ccontrol1real	cmp #13			; return code
		bne cn13
		jmp creturn

cn13		ldx $d8			; insert mode?
		bne coutinverse

		cmp #20			; delete code
		bne cn20
		tya
		bne ce759		;X=0?
		jsr cmovebackoverboundary
		jmp cprintspace

ce759		cpy #40
		bne *+4
		dec $d6			;Y
		dey
		sty $d3			;X
		jsr csynccoloraddr	;ea24
ce762		iny
		.if SUPERCPU=1
		lda ($d1),y
		dey
		sta ($d1),y
		iny
		lda ($f3),y
		dey
		.else
		lax ($f3),y		;Illegal opcodes rulez ;)
		lda ($d1),y
		dey
		sta ($d1),y
		txa
		.fi
		sta ($f3),y
		iny
		cpy $d5			;current logical linelength
		bne ce762

cprintspace	lda #$20		; space
		sta ($d1),y
		lda $0286
		sta ($f3),y
		jmp cexit

cn20		ldx $d4
		bne coutinverse

		cmp #18			;  reverse code
		bne cn18
		sta $c7
cn18		cmp #19			; home code
		bne cn19
		jsr chome
cn19		cmp #29			; csr right
		bne cn29

		cpy #39
		beq ce8c2b
		cpy #79
		bne ce8c2qb

ce8c2b		ldx $d6			;Y
		cpx #25
		beq ce8c2qb
		inc $d6			;Y
ce8c2qb
		cpy $d5			;current logical linelength
		iny
		bcc ce7a8
		dec $d6			;Y
		jsr cnextline
		ldy #$00
ce7a8		sty $d3			;X
		jmp cexit

cn29		cmp #17			; csr down
		bne cn17
		clc
		tya
		adc #40
		tay
		inc $d6			;Y
		cmp $d5			;current logical linelength
		bcc ce7a8
		beq ce7a8
		dec $d6			;Y
ce7c0		sbc #40
		bcc ce7c8
		sta $d3			;X
		bne ce7c0
ce7c8		jsr cnextline
		jmp cexit

cn17		jsr ccheckcolor
		cmp #14
		bne cn14
                lda #2
		#orasta_a $d018
		jmp cexit

cn14		cmp #8
		bne cn8
		lda #$80
		ora $0291
		gmi cec72
cn8		cmp #9
		bne cn9
		lda #$7f
		and $0291
cec72		sta $0291
cn9
ce826		jmp cexit
;--------------------------------------------
ccontrol2real	cmp #13			; shift return
		bne cn141
		jmp creturn

cn141		ldx $d4			; " mode?
		bne ce82d

		cmp #20			; insert
		bne cn148
		ldy $d5			;current logical linelength
		lda ($d1),y		;last char space?
		cmp #$20
		bne ce7fe
		cpy $d3			;X
		bne ce805
ce7fe		cpy #79			;No insert here...
		beq ce826
		jsr cinsertblankhere
ce805		ldy $d5			;current logical linelength
		jsr csynccoloraddr	;ea24
ce80a		dey
		.if SUPERCPU=1
		lda ($d1),y
		iny
		sta ($d1),y
		dey
		lda ($f3),y
		iny
		.else
		lax ($f3),y		;Illegal opcodes rulez ;)
		lda ($d1),y
		iny
		sta ($d1),y
		txa
		.fi
		sta ($f3),y
		dey
		cpy $d3			;X
		bne ce80a
		inc $d8
		jmp cprintspace

cn148		ldx $d8			; Insert?
		beq ce832

ce82d		ora #$40
		jmp coutinverse

ce832		cmp #17			; csr up
		bne cn145		;C=1
		ldx $d6			;Y
		beq ce871		;already on top
		dec $d6			;Y
		tya			;X
		sbc #40
		bcc ce847
		sta $d3			;X
		bcs ce871
ce847		jsr csetaddrofcurline
		bne ce871

cn145		cmp #18			; reverse off
		bne cn146
		#lda0
		sta $c7

cn146		cmp #29			; csr left
		bne cn157
		tya
		beq ce864		;on the left...
		cpy #40
		bne *+4
		dec $d6			;Y
		dec $d3			;X
		jmp cexit

ce864		jsr cmovebackoverboundary
		jmp cexit

cn157		cmp #19			; clr code
		bne ce874
		jsr cclr
ce871		jmp cexit

ce874		ora #$80
		jsr ccheckcolor
		cmp #142
		bne cn142
                .if SUPERCPU=1
                lda #2
                trb $d018
                .else
		lda $d018
		and #$fd
		sta $d018
                .fi
cn142		jmp cexit
;--------------------------------

; set next line number

cnextline	lsr $c9
		ldx $d6			;Y
ce880		inx
		cpx #25
		bne *+5
		jsr cscrollscr
		lda $d9,x
		bpl ce880
		stx $d6			;Y
		jmp csetaddrofcurline


; action for return

creturn		ldx #$00
		stx $d8
		stx $c7
		stx $d4
		stx $d3			;X
		jsr cnextline
		jmp cexit

; check for colour change codes

ccheckcolor	ldx #$0f
ce8cd		cmp ccolors,x
		beq ce8d6
		dex
		bpl ce8cd
		rts

ce8d6		stx $0286
		rts


; colour key codes

ccolors		.byte $90,$05,$1c,$9f,$9c,$1e,$1f,$9e
		.byte $81,$95,$96,$97,$98,$99,$9a,$9b

; scroll screen

cscrollscr	lda $ac
		pha
		lda $ad
		pha
		lda $ae
		pha
		lda $af
		pha
ce8f6					;      ldx #$ff
		dec $d6			;Y
		dec $c9
		dec $02a5
ce8ff					;      inx
					;      .if SMOOTHSCROLL=1
					;      jsr csmooth
					;      .fi
					;      jsr ccalcscraddress	;e9f0
					;      cpx #24
					;      bcs ce913
					;      ldy cscrlinelow+1,x
					;      lda $da,x
					;      jsr cmovescrline
					;      bmi ce8ff
		ldx #40
ud1		lda $400,x
		sta $3d8,x
		lda $d800,x
		sta $d7d8,x
		inx
		bne ud1
ud2		lda $500,x
		sta $4d8,x
		lda $d900,x
		sta $d8d8,x
		inx
		bne ud2
ud3		lda $600,x
		sta $5d8,x
		lda $da00,x
		sta $d9d8,x
		inx
		bne ud3
		ldx #24
ud4		lda $6e8,x
		sta $6c0,x
		lda $dae8,x
		sta $dac0,x
		inx
		bne ud4
		ldx #24
ce913		jsr cclearoneline	;e9ff
		ldx #$00
		asl $d9
ce918		asl $da,x
		ror $d9,x
		inx
		cpx #24
		bne ce918		;C=1
		ror $f1			;Set high bit
		lda $d9
		bpl ce8f6		;Half line, one more time...
		inc $d6			;Y
		inc $02a5
		ldx #$7f
		stx $dc00
		lda $dc01
		cmp #$fb
		stx $dc00		;???
		bne ce956		;No control hold
		ldy #20
ce94d		bit $d011
		bmi *-3
		bit $d011		;This works on scpu ;)
		bpl *-3
		dey
		bne ce94d
		sty $c6
ce956		ldx $d6			;Y
ce958		pla
		sta $af
		pla
		sta $ae
		pla
		sta $ad
		pla
		sta $ac
		rts

; insert blank line in screen

cinsertblankhere ldx $d6		;Y
cinsertblank	inx
		lda $d9,x
		bpl cinsertblank
		stx $02a5
		cpx #$18
		beq ce981
		bcc ce981
		jsr cscrollscr
		ldx $02a5
		dex
		dec $d6			;Y
		jmp ce6da

ce981		lda $ac
		pha
		lda $ad
		pha
		lda $ae
		pha
		lda $af
		pha
		ldx #$19
ce98f		dex
		jsr ccalcscraddress	;e9f0
		cpx $02a5
		bcc ce9a6
		beq ce9a6
		ldy cscrlinelow-1,x
		lda $d8,x
		jsr cmovescrline
		bmi ce98f
ce9a6		jsr cclearoneline	;e9ff
		ldx #23
ce9ab		cpx $02a5
		bcc ce9bf
		asl $da,x
		ldy $d9,x
		cpy #$80
		ror $da,x
		dex
		bne ce9ab
ce9bf		ldx $02a5
		jsr ce6da
		jmp ce958

; move one screen line

cmovescrline	sty $ac
		sty $ae
		and #$03
		ora $0288
		sta $ad
		and #$03
		ora #$d8
		sta $af
		jsr csynccoloraddr	;ea24
		ldy #39
ce9d4		lda ($ac),y
		sta ($d1),y
		lda ($ae),y
		sta ($f3),y
		dey
		bpl ce9d4
		rts

; fetch screen addresses

ccalcscraddress	lda cscrlinelow,x
		sta $d1
		lda $d9,x
		and #3
		ora $0288
		sta $d2
		rts


; clear one screen line

cclearoneline	ldy #39
		jsr ccalcscraddress	;e9f0
		jsr csynccoloraddr	;ea24
cclearonelinelp	lda $0286
		sta ($f3),y
		lda #$20
		sta ($d1),y
		dey
		bpl cclearonelinelp
		rts

; set colour memory adress parallel to screen

csynccoloraddr	lda $d1
		sta $f3
		lda $d2
		and #$03
		ora #$d8
		sta $f4
		rts

cscrlinelow	.byte $00,$28,$50,$78,$a0
		.byte $c8,$f0,$18,$40,$68
		.byte $90,$b8,$e0,$08,$30
		.byte $58,$80,$a8,$d0,$f8
		.byte $20,$48,$70,$98,$c0

;		.if SMOOTHSCROLL=1
;csmooth		bne aa1
;		sei
;		ldx #16+6+8
;hdtnd		ldy #2
;		lda #248
;htuhi		cmp $d012
;		bne *-3
;		cmp $d012
;		beq *-3
;		dey
;		bne htuhi
;		stx $d011
;		dex
;		cpx #15+8
;		bne hdtnd
;		ldy #40
;ohdh		cpy $d012
;		bne *-3
;		bit $d011
;		bmi ohdh
;		ldx #0
;hp		rts
;aa1		cpx #$0d
;		bne hp
;		lda #16+7+8
;		sta $d011
;		rts
;		.fi

getcconv	.proc
		ldx #0
cy		lda cconv,x
		sta $1e00,x
		dex
		bne cy
		lda #34
		sta $1e00+34
		sta $1e00
		rts
		.pend
